/*************************************************************
*
* Project     : bc_svrd
* Source Name : recv_bc
* Purpose     : BC   ú Ÿ Ѵ.
* Version     : 1.0
* Date        : 2001.06.15
* Author      :   
* History     :
* Tested      : 2001.06.15
* libary    
   CSList     : Ͽ  Ÿ ϱ  ũ帮Ʈ
   Cclientsock: Client Socket Ŭȭ
   Clog       : log ϴ Ŭ  
*
*************************************************************/
#include "recv_bc.h"

/*************************************************************
۽   ü
*************************************************************/
struct field
{
    char tr_code[10];          //transaction code
    char sender_code[3];       //۽ű ڵ
	char tele_code[5];         //ڵ
	char data_code[6];         //ڷᱸ ڵ
	char tele_num[7];          //  ȣ ڵ
	char send_date[7];         // 
	char send_time[7];         // ð 
	char re_code[3];           //ڵ
	char crypt[7];             //ȣ
	char reserved[13];         //
	char mg_info[4];           //Ÿ  08x0 
	char data_header[31];      //08x0 
	char block_no[5];          //block number
	char missing_num[101];     // ڷ ȣ
};

Daemon::Daemon()
{
   a = -1;
}

void Daemon::start()
{
   switch(fork())
   {
      case 0:
         break;
      case -1:
         _exit(0);
      default:
         _exit(0);
   }

   if(setsid() < 0)
   {
      a = -1;
   }

   umask(0);
   //open("/dev/null", O_RDWR);
   dup(0);
   dup(0);
   a = 0;

}

void Daemon::GetPid()
{
   FILE *fp;
   int pid;
   char buf[6];

   fp = fopen("./pid.log", "w");
   if(fp == NULL)
   {
      //printf("recv pid file open error\n");
      exit(0);
   }

   pid = getpid();
   sprintf(buf,"%d",pid);

   fputs(buf,fp);
   fclose(fp);
}

int Daemon::DaemonGet()
{
   return a;
}
//2003.04.03 Ʒ  
Clog* mylog; //log  Ŭ
char temp[1000];

/*****************************************************
  ۾ óѴ.
*****************************************************/
void child_process(void);

/*****************************************************
 Ÿ ۽Ѵ.
*****************************************************/
int send_packet(field jun, Cclientsocket *send_socket);


void cp_arr( char * dest, char * src, int st, int len );
unsigned short int rport, sport;
int main(int argc, char *argv[])
{
	signal(SIGCHLD, SIG_IGN); //child prosess signal Ѵ.  ǹ 
	int child_pid;

	Daemon daemon;            //ȭ ü 
	if(argc < 3)
	{
		rport = 2106;
		sport = 2107;
	}
	else
	{
		rport = (unsigned short int)atoi(argv[1]);
		sport = (unsigned short int)atoi(argv[2]);
	}
	printf("recv port=%d\n", rport);
	printf("send port=%d\n", sport);

	daemon.start();        //ȭ 
	
	while(1)               //  鼭 ۾.
	{		
		child_pid = fork();		
		switch(child_pid)
		{
			case 0:
				printf("fork\n");
			    child_process();
				exit(1);
			case -1:
				printf("fork error\n");
				exit(0);
			default:
				wait((int *)0);	
		}
	}

}

void child_process(void)
{
	field junmun;
	char buf[4500];
	char tele_code[5];
	char re_code[3];
	char mg_info[4];
	char block_no[5];
	char record_no[4];
	char datapart_len[5];            //DATA κ  
	char data_cnt[5];                //Ÿ Ǽ
	char one_data_len[5];            //1 DATA 
	char data_m[4019];               //Ÿ
	int data_len;
	int errcode;
	//int check_flg;
	CSList *List;                    //BC   Ÿ   ܼ  Ʈ ü .
	Cclientsocket *recv_socket;      // 
    Cclientsocket *send_socket;      //۽ 

	recv_socket = new Cclientsocket;
    send_socket = new Cclientsocket;

	mylog = new Clog("bc_svrd.");      //log ü .   Ŀ   ϸ  ϱ  .

	//check_flg = 0;                   	
	// 211.112.6.61 10.1.1.101 ٲ : 2002.02.27
	printf("@1");
    errcode = recv_socket->Open("10.1.2.252", rport, 5); //  .
        printf("error_cd1 = [%d]",errcode);
	if(errcode != 1)
    {
      sprintf(temp, "%s%d","recv_socket Open error!, errCode=", errcode);
	  mylog->writelog(temp);
	  delete recv_socket;
	  delete send_socket;
	  delete mylog;
      exit(1);
    }
	// 211.112.6.61 10.1.1.101 ٲ : 2002.02.27	
    errcode = send_socket->Open("10.1.2.252", sport, 5); //۽  .
    printf("error_cd2 = [%d]",errcode);
	if(errcode != 1)
	{
		sprintf(temp, "%s%d", "send_socket Open error!, errCode=", errcode);
		mylog->writelog(temp);
		delete recv_socket;
		delete send_socket;
		delete mylog;
		exit(1);
	}	
	printf("recv_socket Open!, send_socket Open!\n");

	int missing_err;             // Ÿ üũϱ  
	char miss[2];
	char new_header_file[41];    //header ϸ ȯҶ ̴ .
	char new_data_file[41];
	char old_data_file[41];
	char path[100];
	char data_code[6];
	char ptr[25];
	int status = 0;             //loop  
	
	memset( path,            '\0', sizeof( path            ));
	memset( new_header_file, '\0', sizeof( new_header_file ));
	memset( new_data_file,   '\0', sizeof( new_data_file   ));
	memset( old_data_file,   '\0', sizeof( old_data_file   ));
	memset( ptr,             '\0', sizeof( ptr             ));
	while(1)
	{
		memset( junmun.tr_code,     '\0', sizeof( junmun.tr_code     ));
		memset( junmun.sender_code, '\0', sizeof( junmun.sender_code ));
		memset( junmun.tele_code,   '\0', sizeof( junmun.tele_code   ));
		memset( junmun.data_code,   '\0', sizeof( junmun.data_code   ));
		memset( junmun.tele_num,    '\0', sizeof( junmun.tele_num    ));
		memset( junmun.send_date,   '\0', sizeof( junmun.send_date   ));
		memset( junmun.send_time,   '\0', sizeof( junmun.send_time   ));
		memset( junmun.re_code,     '\0', sizeof( junmun.re_code     ));
		memset( junmun.mg_info,     '\0', sizeof( junmun.mg_info     ));
		memset( junmun.data_header, '\0', sizeof( junmun.data_header ));
		memset( tele_code,          '\0', sizeof( tele_code          ));
		memset( re_code,            '\0', sizeof( re_code            ));
		memset( junmun.mg_info,     '\0', sizeof( junmun.mg_info     ));
		memset( junmun.block_no,    '\0', sizeof( junmun.block_no    ));
		memset( junmun.missing_num, '\0', sizeof( junmun.missing_num ));
		//memset( buf,             '\0', sizeof( buf             ));
		if(status == 1)               //1̸ .
		{
			break;
		}
		int len;
		len = recv_socket->recv(buf);
		printf("recv length=%d\n", len);
		if(len <= 0)
		{
			printf("client disconnect\n");
			sprintf(temp, "client disconnect");
			mylog->writelog(temp);
			delete recv_socket;
			delete send_socket;
			delete mylog;
			exit(1);
		}
		cp_arr( junmun.sender_code, buf, 10, 2); 
		cp_arr( tele_code,          buf, 12, 4);
		cp_arr( junmun.data_code,   buf, 16, 5);
		cp_arr( junmun.tele_num,    buf, 21, 6);
		cp_arr( junmun.send_date,   buf, 27, 6);
		cp_arr( junmun.send_time,   buf, 33, 6);
		cp_arr( re_code,            buf, 39, 2);

		sprintf(temp, "۽ű ڵ[%s]", junmun.sender_code);
		mylog->writelog(temp);
		sprintf(temp, "ڵ[%s]", tele_code);
		mylog->writelog(temp);
		sprintf(temp, "ڷᱸ ڵ[%s]", junmun.data_code);
		mylog->writelog(temp);
		sprintf(temp, " ȣ[%s]", junmun.tele_num);
		mylog->writelog(temp);
		sprintf(temp, " [%s]", junmun.send_date);
		mylog->writelog(temp);
		sprintf(temp, " ð[%s]", junmun.send_time);
		mylog->writelog(temp);
		sprintf(temp, " ڵ[%s]", re_code);
		mylog->writelog(temp);

		switch(atoi(tele_code))
		{
			case 800:                   //*  
				/*if(strlen(buf) != 91)
					sprintf(junmun.re_code, "%-2s", "30");
				else
					sprintf(junmun.re_code, "%-2s", "00");
				*/
				sprintf(junmun.re_code, "%2s", "00");
				cp_arr( junmun.mg_info,     buf, 59, 3);
				cp_arr( junmun.data_header, buf, 62, 30);
				sprintf(temp, "800 ");
				mylog->writelog(temp);
				sprintf(temp, "Ÿ [%s]", junmun.mg_info);
				mylog->writelog(temp);
				sprintf(temp, "data header[%s]", junmun.data_header);
				mylog->writelog(temp);
				switch(atoi(junmun.mg_info))
				{
					case 1:               // 
						sprintf(temp, " ");
						mylog->writelog(temp);
						List = new CSList(junmun.data_code);
						strcpy(data_code, junmun.data_code);
						sprintf(junmun.tr_code, "%9s", "aaaaaaaaa");
						sprintf(junmun.tele_code, "%4s", "0810");
						sprintf(junmun.crypt, "%6s", " ");
						sprintf(junmun.reserved, "%12s", " ");
						printf("send start\n");
						if(send_packet(junmun, send_socket) == -1)
						{
							sprintf(temp, "send_packet error! 0800/001 ");
							mylog->writelog(temp);
							delete recv_socket;
							delete send_socket;
							if(List != NULL)
								delete List;
							delete mylog;
							exit(1);
						}
						printf("send end\n");
						break;
					case 2:               // 
						sprintf(temp, " ");
						mylog->writelog(temp);
						if(List == NULL)
						{
							sprintf(temp, "List allocation error!");
							mylog->writelog(temp);
							delete recv_socket;
							delete send_socket;
							if(List != NULL)
								delete List;
							delete mylog;
							exit(1);
						}
						List->write2file();
						List->delete_all();
						status = 1;

						sprintf(junmun.tr_code, "%9s", "aaaaaaaaa");
						sprintf(junmun.tele_code, "%4s", "0810");
						sprintf(junmun.crypt, "%6s", " ");
						sprintf(junmun.reserved, "%12s", " ");

						if(send_packet(junmun, send_socket) == -1)
						{
							sprintf(temp, "send_packet error! 0810/002 \n");
							mylog->writelog(temp);
							delete recv_socket;
                     		delete send_socket;
							if(List != NULL)
								delete List;
							delete mylog;
                     		exit(1);
						}

						break;
				}
				break;
			case 2100:                   //Ÿ 
				sprintf(temp, "<<<<<<<<<<<<<<<<<<<<<<<<<<<2100  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");
				mylog->writelog(temp);
				sprintf(temp, "recv size[%d]", strlen(buf));
				mylog->writelog(temp);
				cp_arr( block_no, buf, 59, 4);
				sprintf(temp, "block_no[%s]", block_no);
				mylog->writelog(temp);
				cp_arr( record_no, buf, 63, 3);
				sprintf(temp, "record_no[%s]", record_no);
				mylog->writelog(temp);
				cp_arr( datapart_len, buf, 66, 4);
				cp_arr( data_cnt, buf, 70, 4);
				cp_arr( one_data_len, buf, 74, 4);
				data_len = atoi(one_data_len) * atoi(data_cnt);
				cp_arr( data_m, buf, 78, data_len);
				if(List == NULL)
				{
					sprintf(temp, "List allocation error! 2100 \n");
					mylog->writelog(temp);
					delete recv_socket;
					delete send_socket;
					delete mylog;
					exit(1);
				}
				if(atoi(datapart_len) != (data_len + 19)) //Ÿ κ  üũ
				{
					sprintf(temp, "DATA κ  [%d, %d] miss match", atoi(datapart_len), data_len); 
					mylog->writelog(temp);
					break;
				}
				else
				{
					sprintf(junmun.re_code, "%-2s", "00");
					sprintf(temp, "record no[%d]", atoi(record_no));
					mylog->writelog(temp);
					sprintf(temp, "List->get_block_no(%d), atoi(block_no)[%d]", List->get_block_no(), atoi(block_no));
					mylog->writelog(temp);
					/*if(check_flg == 0 && atoi(record_no) == 3)
					{
						check_flg = 1;
						break;
					}*/
					if(List->get_block_no() == atoi(block_no))      //1 Ŭ 
					  List->ordered_insert(atoi(block_no), atoi(record_no), data_m, atoi(data_cnt), atoi(one_data_len));
					else if(List->get_block_no() != atoi(block_no)) //ο block_no 
					{
						List->write2file();
						List->delete_all();                          //1 Ŭ  head tail   
					  List->ordered_insert(atoi(block_no), atoi(record_no), data_m, atoi(data_cnt), atoi(one_data_len));
					}
					printf("block_no[%d]\n", atoi(block_no));
					//List->print();
				}
				
				break;
			case 2200:                                               // Ȯ û 
				sprintf(temp, "2200  ");
				mylog->writelog(temp);
				sprintf(junmun.tr_code, "%-9s", "aaaaaaaaa");
				sprintf(junmun.tele_code, "%4s", "2210");
				sprintf(junmun.re_code, "%-2s", "00");
				cp_arr( block_no, buf, 59, 4);
				sprintf(junmun.block_no, "%04d", List->get_block_no());
				printf("2200 block_no=%d\n", List->get_block_no());
				if(atoi(block_no) != List->get_block_no())             //block_no miss match 
				{
					sprintf(junmun.re_code, "%-2s", "01");
				}
				memset( junmun.missing_num, '0', sizeof( junmun.missing_num )-1); //ʱġ   	
				for(int i = 0; i < 100; i++)
				{
					missing_err = List->find_node(i+1);
					printf("<<<<<<<<<<<<<<<<<<< [%d]>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n", missing_err);
					
					sprintf(miss, "%d", missing_err);
					junmun.missing_num[i] = miss[0];
				}
				send_packet(junmun, send_socket);
				break;
		} //end of switch

	} //end of while

	//sleep(5);
	delete List;
    delete send_socket;
	delete recv_socket;
	sprintf(temp, "Ÿ ڵ[%s]", data_code);
	mylog->writelog(temp);
	if(data_code[4] =='1') //header file̸
    {
      char buf[50];
      memset(buf, '\0', sizeof(buf));
      printf("header file recive\n");
      strcpy(path, "/project/BC/BC/");
      strcat(path, data_code);
      ifstream in(path, ios::in );
      in.getline( buf, 41, '\n' );
      strcpy(new_data_file, "/project/BC/BC/");
      sprintf(temp, "buffer [%d]", strlen(buf));
	  mylog->writelog(temp);
      if(strstr(buf, "_P"))
      {
         cp_arr(ptr, buf, 11, 20);
      }
      else
      {
         cp_arr(ptr, buf, 11, 14);
      }
      sprintf(temp, "Ͽ  Ÿ [%s]", ptr);
	  mylog->writelog(temp);
      in.close();
      strcat(new_data_file, ptr);
      strcpy(old_data_file,"/project/BC/BC/");
      strncat(old_data_file, data_code, 4);
      strcat(old_data_file, "2");
      sprintf(temp, "old_data_file=%s, new_data_file=%s", old_data_file, new_data_file);
	  mylog->writelog(temp);
      if(rename(old_data_file, new_data_file) == -1)
      {
         sprintf(temp, "Ÿ    ʾҽϴ.\n");
		 mylog->writelog(temp);
		 delete mylog;
         exit(1);
      }
	//strcpy(new_header_file, "/project/BC/BC/");
      strncpy(new_header_file, new_data_file, strlen(new_data_file)-3);
      strcat(new_header_file, "inf");
      printf("new_header_file=%s\n", new_header_file);
      if(rename(path, new_header_file) == -1)
      {
         sprintf(temp, "rename error!");
		 mylog->writelog(temp);
         sprintf(temp, "data_code=%s, new_header_file=%s", path, new_header_file);
		 mylog->writelog(temp);
      }


   }
   else
   {
      char buf[50];
      memset(buf, '\0', sizeof(buf));
      printf("data file recive\n");
      strcpy(path, "/project/BC/BC/");
      strncat(path, data_code,  4);
      strcat(path, "1");
      sprintf(temp, "header file name[%s]\n", path);
	  mylog->writelog(temp);
      if(access(path, 06) == -1)
      {
         sprintf(temp, "header file   ʾҽϴ.\n");
		 mylog->writelog(temp);
		 delete mylog;
         exit(0);

      }
      ifstream in(path, ios::in );
      in.getline( buf, 41, '\n' );
      strcpy(new_data_file, "/project/BC/BC/");
      sprintf(temp, "buffer [%d]", strlen(buf));
	  mylog->writelog(temp);
	  if(strstr(buf, "_P"))
	  {
		 cp_arr(ptr, buf, 11, 20);
	  }
	  else
	  {
	     cp_arr(ptr, buf, 11, 14);
	  }

      sprintf(temp, "Ͽ  Ÿ [%s]", ptr);
	  mylog->writelog(temp);
      in.close();
      strcat(new_data_file, ptr);
      strcpy(old_data_file,"/project/BC/BC/");
      strncat(old_data_file, data_code, 4);
      strcat(old_data_file, "2");
      sprintf(temp, "old_data_file=%s, new_data_file=%s", old_data_file, new_data_file);
	  mylog->writelog(temp);
      if(rename(old_data_file, new_data_file) == -1)
      {
         sprintf(temp, "Ÿ    ʾҽϴ.");
		 mylog->writelog(temp);
		 delete mylog;
         exit(1);
      }
      //strcpy(new_header_file, "/project/BC/BC/");
      strncpy(new_header_file, new_data_file, strlen(new_data_file)-3);
      strcat(new_header_file, "inf");
      sprintf(temp, "new_header_file=%s", new_header_file);
	  mylog->writelog(temp);
	  if(rename(path, new_header_file) == -1)
      {
         sprintf(temp, "rename error!");
		 mylog->writelog(temp);
         sprintf(temp, "data_code=%s, new_header_file=%s", path, new_header_file);
		 mylog->writelog(temp);
      }

   }

}
int send_packet(field jun, Cclientsocket *Csocket)
{
	char packet[200];
	int send_len;
	send_len = 0;
	memset(packet, '\0', sizeof(packet));
	strcpy(packet, jun.tr_code);
//	printf("tr code[%s]\n", jun.tr_code);
	strcat(packet, jun.sender_code);
   //printf("sender_code[%s]\n", jun.sender_code);
	strcat(packet, jun.tele_code);
	//printf("tele_code[%s]\n", jun.tele_code);
	strcat(packet, jun.data_code);
	//printf("data_code[%s]\n", jun.data_code);
	strcat(packet, jun.tele_num);
	//printf("tele_num[%s]\n", jun.tele_num);
	strcat(packet, jun.send_date);
	//printf("send_date[%s]\n", jun.send_date);
	strcat(packet, jun.send_time);
	//printf("send_time[%s]\n", jun.send_time);
	strcat(packet, jun.re_code);
	//printf("re_code[%s]\n", jun.re_code);
	strcat(packet, jun.crypt);
	//printf("crypt[%s]\n", jun.crypt);
	strcat(packet, jun.reserved);
	//printf("reserved[%s]\n", jun.reserved);
	strcat(packet, jun.block_no);
	//printf("block_no[%s]\n", jun.block_no);
	strcat(packet, jun.mg_info);
	//printf("mg_info[%s]\n", jun.mg_info);
	strcat(packet, jun.data_header);
	//printf("missing_num[%s], len[%d]\n", jun.missing_num, strlen(jun.missing_num));
	strcat(packet, jun.missing_num);
	sprintf(temp, "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<bgein send function>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
	mylog->writelog(temp);
	sprintf(temp, "contents of packet[%s] and length of packet[%d]", packet, strlen(packet));
	mylog->writelog(temp);
        
        printf(temp, "contents of packet[%s] and length of packet[%d]", packet, strlen(packet));
        
	send_len = Csocket->send(packet);
		
	printf("send_len = [%d]\n", send_len);
	
	if(send_len == -1)
	{
		printf("send error\n");
		return -1;
	}
	sprintf(temp, "send_len[%d] tot_len[%d]", send_len, strlen(packet));
	mylog->writelog(temp);
	sprintf(temp, "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<end send function>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
	mylog->writelog(temp);
	return 1;
}
void cp_arr( char * dest, char * src, int st, int len )
{
	int ndx = 0;
	int ind ;

	for( ind = st - 1; ind < st+len-1; ind ++, ndx ++)
	{
		/*if( src[ind] == ' ' )
			break;*/
		dest[ndx] = src[ind] ;
	}
	dest[ndx] = '\0';
}
