/************************************************************************
*
* Project     : bc_svrd
* Source Name : CSList
* Purpose     : Socket   Ÿ  linked list
* Version     : 1.0
* Date        : 2001.06.15
* Author      :   
* History     :
* Tested      : 2001.06.15
*
************************************************************************/
#include "CSList.h"
//. Ӹ  , ѹ 0 ʱȭ,  .
CSList::CSList(char *fname)
{
	char path[150];
    memset(path, '\0', sizeof(path));
	m_head = new node;
	m_tail = new node;
	m_head->next = m_tail;
	m_tail->next = m_head;
	m_status = 0;               //0 ʱġ,  Ŭ , 1 Ŭ Ϸ
	m_bl_no = 1;		    // kmj  
	memset(m_fname, '\0', sizeof(m_fname));
	strcpy(m_fname, fname);
	strcpy(path, "/project/BC/BC/");
	strcat(path, m_fname);
	printf("file name[%s]\n", path);
	if((m_bc_fd = fopen(path, "w")) == NULL)
	{
		printf("Could not open file %s\n", path);
		exit(0);
	}
	printf("file name2[%s]\n", path);
}

CSList::~CSList()
{
	fclose(m_bc_fd);
	delete_all();
	delete m_head;
	delete m_tail;
}
// .
int CSList::get_status(void)
{
	return(m_status);
}
// .
void CSList::set_status(int value)
{
	m_status = value;
}

//block number set	KMJ ߰
void CSList::set_block_no(int value)
{
	m_bl_no = value;
}

//block number 
int CSList::get_block_no(void)
{
	return(m_bl_no);
}
//record number key ˻
int CSList::find_node(int rec_no)
{
	node *p;
	p = m_head;

	while(p != m_tail)
	{
		if(p->record_no ==rec_no)
			return 1;
		p = p->next;
	}
	return 0;         //̼ 0,  1
}
//record number Է.
int CSList::ordered_insert(int b_num, int r_num, char *data, int cnt, int len)
{
	node *s;
	node *p;
	node *r;
	p = m_head;
	s = p->next;

	while(s->record_no <= r_num && s != m_tail)
	{
		p = p->next;
		s = p->next;
	}
	r = new node;
	if(r == NULL)
	{
		cout << "Error! No memory for node!!";
		return -1;
	}
	r->record_no = r_num;
	r->block_no = b_num;
	strcpy(r->data_m, data);
	r->data_cnt = cnt;
	r->data_len = len;
	p->next = r;
	r->next = s;
	m_bl_no = b_num;
	printf("SList record no[%d]\n", r->record_no);
	return 1;
}
//Ӹ     
void CSList::delete_all(void)
{
	node *p;
	node *s;
	p = m_head->next;
	while(p != m_tail)
	{
		s = p;
		p = p->next;
		delete s;
	}
	m_head->next = m_tail;
	m_tail->next = m_head;
}
// block record Ϸ .
int CSList::write2file(void)
{
	node *p;
	int i,j;
	char t_buf[1000];
    p = m_head->next;

 	while(p != m_tail)
   	{
		j = 1;
	/*	printf("Ÿ Ǽ[%d], Ÿ [%d]\n", p->data_cnt, p->data_len);
		printf("Ÿ[%d]\n", sizeof(p->data_m));*/
		for(i=1;i<=p->data_cnt; i++)
		{
			cp_arr(t_buf, p->data_m, j, p->data_len);
			//printf("ġ[%d] [%d]\n", j, p->data_len);
			fprintf( m_bc_fd, "%s\n", t_buf);
			//printf("buf[%s]\n", t_buf);
			memset(t_buf, '\0', sizeof(t_buf));
			j = j + p->data_len;
		}
		p = p->next;
	}

	return 1;		
}

void CSList::print(void)
{
   printf("block_no[%d]\n", m_bl_no);
   node *p;
   node *s;
   p = m_head->next;
   while(p != m_tail)
   {
		printf("p->block_no[%d]\n", p->block_no);
    	printf("p->record_no[%d]\n", p->record_no);
		printf("data[%s]\n", p->data_m);
  	    s = p;
        p = p->next;
        delete s;
   }
}

void CSList::cp_arr( char * dest, char * src, int st, int len )
{
	int ndx = 0;
	int ind ;

	for( ind = st - 1; ind < st+len-1; ind ++, ndx ++)
	{
		/*if( src[ind] == ' ' )
		break;*/
		dest[ndx] = src[ind] ;
	}
	
	dest[ndx] = '\0';
}


