#include "klib.h"


Daemon::Daemon()
{
	a = -1;
}

void Daemon::start()
{
	switch(fork())
	{
		case 0:
			break;
		case -1:
			_exit(0);
		default:
			_exit(0);
	}

	if(setsid() < 0)
	{
		a = -1;
	}

	umask(0);
	open("/dev/null", O_RDWR);
	dup(0);
	dup(0);
	a = 0;

}


void Daemon::GetPid()
{
	FILE *fp;
	int pid;
	char buf[6];

	fp = fopen("./pid.log", "w");
	if(fp == NULL)
	{
		//printf("recv pid file open error\n");
		exit(0);
	}

	pid = getpid();
	sprintf(buf,"%d",pid);

	fputs(buf,fp);
	fclose(fp);
}


int Daemon::DaemonGet()
{
	return a;
}

CFileFind::CFileFind(const char *d)
{
	memset(m_file_name, '\0', sizeof(m_file_name));
	printf("pass1-1\n");
	memset(m_dir_name, '\0', sizeof(m_dir_name));
	strcpy(m_dir_name, d);
}

int CFileFind::find(const char *pattern)
{
	struct dirent *dp;
	char old_name[100];
	char new_name[100];

	DIR *dirp ;
	if((dirp = opendir(m_dir_name)) == NULL)
		return -1;

	if(dirp != NULL)
	{
		while(dp = readdir(dirp))
		{
			printf("pass2\n");
			if((fnmatch(pattern, dp->d_name, 0) == 0))
			{
				strcpy(m_file_name, dp->d_name);
				sprintf(old_name, "%s%s", m_dir_name, m_file_name);
				sprintf(new_name, "%s%s.tmp", m_dir_name, m_file_name);
				printf("pass3\n");
				if(rename(old_name, new_name) == -1)
				{
					printf("rename error!\n");
					return -1;
				}
				return 1;
			}
		}
		(void)closedir(dirp);
		return -1;
	}
	else
	{
		printf("pass4\n");
		printf("Couldn't open the directory \n");
		return -1;
	}
}

char* CFileFind::get_file_name(void)
{
	return m_file_name;
}
