/************************************************************************
*
* Project     : bc_svrd
* Source Name : new_CSList
* Purpose     : Socket   Ÿ  linked list
* Version     : 1.3
* Date        : 2001.06.15
* Author      :   
* History     : ڵ带 ȭ 
* Tested      : 2001.06.15
*
************************************************************************/
#include "new_CSList.h"

CSList::CSList(char *fname)
{
	char path[150];
    memset(path, '\0', sizeof(path));
	memset(m_missing_no, '\0', sizeof(m_missing_no));
	memset(m_missing_no, '0', sizeof(m_missing_no)-1);
	m_head = new node;
	m_tail = new node;
	m_head->next = m_tail;
	m_tail->next = m_head;
	m_status = 0;               //0 ʱġ,  Ŭ , 1 Ŭ Ϸ
	m_bl_no = 1;
	m_max_record_no = 0;
	memset(m_fname, '\0', sizeof(m_fname));
	strcpy(m_fname, fname);
	strcpy(path, "/project/BC/BC/");
	strcat(path, m_fname);
	printf("file name[%s]\n", path);
	if((m_bc_fd = fopen(path, "w")) == NULL)
	{
		printf("Could not open file %s\n", path);
		exit(0);
	}
}

CSList::~CSList()
{
	fclose(m_bc_fd);
	delete m_head;
	delete m_tail;
}

int CSList::get_status(void)
{
	return(m_status);
}

void CSList::set_status(int value)
{
	m_status = value;
}

int CSList::get_block_no(void)
{
	return(m_bl_no);
}

int CSList::find_node(int rec_no)
{
	node *p;
	p = m_head;

	while(p != m_tail)
	{
		if(p->record_no ==rec_no)
			return 1;
		p = p->next;
	}
	return 0;         //̼ 0,  1
}
int CSList::ordered_insert(int b_num, int r_num, char *data, int cnt, int len)
{
	node *s;
	node *p;
	node *r;
	p = m_head;
	s = p->next;
	if(m_bl_no != b_num)
	{
		if(check_missing_num() == -1) //߰  ִ Ȯ
		{
			return -3;
		}
		this->write2file();
		memset(m_missing_no, '\0', sizeof(m_missing_no));
		memset(m_missing_no, '0', sizeof(m_missing_no)-1);
		m_max_record_no = 0;
	}
	if(m_missing_no[r_num-1] == 1)   //ߺ ڵȣ 
	{
		return -2;
	}
	while(s->record_no <= r_num && s != m_tail)
	{
		p = p->next;
		s = p->next;
	}
	r = new node;
	if(r == NULL)
	{
		cout << "Error! No memory for node!!";
		return -1;
	}
	r->record_no = r_num;
	r->block_no = b_num;
	strcpy(r->data_m, data);
	r->data_cnt = cnt;
	r->data_len = len;
	m_missing_no[r_num-1] = '1';
	if(r_num > m_max_record_no)
		m_max_record_no = r_num;
	p->next = r;
	r->next = s;
	m_bl_no = b_num;
	//printf("SList record no[%d]\n", r->record_no);
	return 1;
}

void CSList::delete_all(void)
{
	node *p;
	node *s;
	p = m_head->next;
	while(p != m_tail)
	{
		s = p;
		p = p->next;
		delete s;
	}
	m_head->next = m_tail;
	m_tail->next = m_head;
}

int CSList::write2file(void)
{
	node *p;
	node *s;
	int i,j;
	char t_buf[1000];
    p = m_head->next;

 	while(p != m_tail)
   	{
		j = 1;
		for(i=1;i<=p->data_cnt; i++)
		{
			cp_arr(t_buf, p->data_m, j, p->data_len);
			fprintf( m_bc_fd, "%s\n", t_buf);
			memset(t_buf, '\0', sizeof(t_buf));
			j = j + p->data_len;
		}
		s = p;
		p = p->next;
		delete s;
	}

	return 1;		
}

void CSList::print(void)
{
	printf("block_no[%d]\n", m_bl_no);
	node *p;
   node *s;
   p = m_head->next;
   while(p != m_tail)
   {
		printf("p->block_no[%d]\n", p->block_no);
		printf("p->record_no[%d]\n", p->record_no);
		printf("data[%s]\n", p->data_m);
      s = p;
      p = p->next;
      delete s;
   }
}

void CSList::cp_arr( char * dest, char * src, int st, int len )
{
	int ndx = 0;
	int ind ;

	for( ind = st - 1; ind < st+len-1; ind ++, ndx ++)
	{
		/*if( src[ind] == ' ' )
		break;*/
		dest[ndx] = src[ind] ;
	}
	
	dest[ndx] = '\0';
}

char* CSList::get_missing_num(void)
{
	return(m_missing_no);
}

int CSList::check_missing_num(void)
{
	for(int i = 0; i < m_max_record_no; i++)
	{
		if(m_missing_no[i] == '0')
			return(-1);
	}
	return 1;
}
