import java.io.*;
import java.net.*;

class COMIFSVC  implements Runnable
{	
	InfoMgr infoMgr;
	int nrifID;
	
	COMIFSVC(InfoMgr infotab, int id)
	{
		this.infoMgr = infotab;
		nrifID = id;
	}
		
	public void run()
	{
		BCComData bcdata = new BCComData();
		int datasize;
		String   msgCode;
		
		// Data Input ó
		while(true)
		{
			int len = 0;
			
			// ϴܿ Ÿ б
			len = infoMgr.recvLow(bcdata,nrifID);
			if (len < 0) {
				infoMgr.log.writeLog("[IF]DISC ID[" + nrifID + "]");
				infoMgr.discIFConn(nrifID);
				break;
			} else if (len == 0) {
				infoMgr.log.writeLog("[IF]Ÿ ID["+nrifID +"]" );	
				continue;
			}
			
			infoMgr.log.writeLog("IFSIZE = " + len );
			
			// ޽  Ȯ 	
			msgCode = bcdata.getMsgCode();
			if (msgCode.compareTo("0440") == 0) {
				datasize = 78 - BCComDef.BCComDataHeadSize;
			} 
			else if (msgCode.compareTo("0450") == 0) 
			{
				datasize = 1004-BCComDef.BCComDataHeadSize;

				//##debug -s
				//byte[] dd = bcdata.getData();
				//char   fl = (char)dd[58];
				//if ( fl == '2' ) dd[58] = (byte)'9';
				//##debug -e
			}
			else 
			{
				datasize = 0;
				infoMgr.log.writeLog("[IF] MsgCode NG MCod["+msgCode+"]");
				continue;
			}
			
			if (datasize != bcdata.getSize() )
			{
				infoMgr.log.writeLog("[IF] Size Error RcvSize["
						+bcdata.getSize()+"] ReqSize[" +datasize+ "]");
				continue;
			}
			

			
			//  
			synchronized(infoMgr.iftab) {
				infoMgr.iftab.en[nrifID].transSeq = bcdata.getTransSeq();	
			}
			boolean ret = infoMgr.sendUpper(bcdata);
			if (ret != true) {
				infoMgr.log.writeLog("Send Sever NG Seq["+
					   bcdata.getTransSeq() + "]/ID[" +nrifID + "]");

			} else {
				infoMgr.log.writeLog("Send Server OK Seq[" + 
					   bcdata.getTransSeq() + "] ID[" +nrifID + "])");
				
				//## debug -s
				infoMgr.log.objDump(bcdata);
				//## debug -e
			}
		} // end-while
	
	} // end-method
			
		
} //end-class
