import	java.io.*;

class BCComData
{
	byte[] transCode;			// Transaction Code	 9
	byte[] textStartChar;			// Text ù	 3
	byte[] msgCode;				// ڵ			 4
	byte[] transSeq;			// ŷȣ		 12
	byte[] transDate;			// Ͻ		 14
	byte[] rspCode;				// ڵ			 2
	byte[] memberCode;			// ȸȣ		 2
	byte[] reserve;				// 				 18
	int    size;				// DataSize	     4
	byte[] data;				// ʵ

	// Ÿó  static 
	
	//
	// initialize member variables
	//
	public BCComData()
	{
		transCode 		= new byte[9];
		textStartChar		= new byte[3];
		msgCode			= new byte[4];
		transSeq		= new byte[12];
		transDate		= new byte[14];
		rspCode			= new byte[2];
		memberCode		= new byte[2];
		reserve			= new byte[18];
		data			= new byte[1024];
		init();
	}
	
	public void init()
	{
		for (int i =0; i < transCode.length; i++)
			transCode[i] = (byte) ' ';

		for (int i =0; i < textStartChar.length; i++)
			textStartChar[i] = (byte) ' ';

		for (int i =0; i < msgCode.length; i++)
			msgCode[i] = (byte) ' ';

		for (int i =0; i < transSeq.length; i++)
			transSeq[i] = (byte) ' ';

		for (int i =0; i < transDate.length; i++)
			transDate[i] = (byte) ' ';

		for (int i =0; i < memberCode.length; i++)
			memberCode[i] = (byte) ' ';

		for (int i =0; i < reserve.length; i++)
			reserve[i] = (byte) ' ';

		for (int i =0; i < data.length; i++)
			data[i] = (byte) ' ';

		for (int i =0; i < rspCode.length; i++)
			rspCode[i] = (byte) ' ';

	}

	//
	// Getter Functions
	//
	public String getTransCode() { return new String(transCode,0,9); }
	public String getTextStartChar(){ return new String(textStartChar,0,3); }
	public String getMsgCode(){ return new String(msgCode,0,4); }
	public String getTransSeq(){ return new String(transSeq,0,12); }
	public String getTransDate(){ return new String(transDate,0,14); }
	public String getRspCode(){ return new String(rspCode,0,2); }
	public String getMemberCode(){ return new String(memberCode,0,2); }
	public String getReserve(){ return new String(reserve,0,18); }
	public int 	  getSize() { return size; }
	public byte[] getData() { return data; }

	//
	// Setter Functions
	//
	public void setTransCode(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i =0 ; i<tmp.length && i < transCode.length;i++)
			transCode[i] = tmp[i];
	}
	public void setTextStartChar(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < textStartChar.length;i++)
			textStartChar[i] = tmp[i];
	}
	public void setMsgCode(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < msgCode.length;i++)
			msgCode[i] = tmp[i];
	}
	public void setTransSeq(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < transSeq.length;i++)
			transSeq[i] = tmp[i];
	}
	public void setTransDate(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < transDate.length;i++)
			transDate[i] = tmp[i];
	}
	public void setRspCode(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < rspCode.length;i++)
			rspCode[i] = tmp[i];
	}
	public void setMemberCode(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < memberCode.length;i++)
			memberCode[i] = tmp[i];
	}
	public void setReserve(String src)
	{
		byte[] tmp = src.getBytes();	
		for(int i=0; i<tmp.length && i < reserve.length;i++)
			reserve[i] = tmp[i];
	}
	public void setSize(int src)
	{
		size = src;
	}
	public void setData(int srcoffset, byte[] byteArray, int destoffset, int len)
	{
		for (int i=0; i < len; i++) 
		{
			data[i+srcoffset] = byteArray[i+destoffset];
		}
	}


	//
	// Object <==> byte Array
	//
	public byte[] toByte()
	{
		ByteArrayOutputStream tmpOutByteArray 
						= new ByteArrayOutputStream(BCComDef.BCComDataHeadSize);
		DataOutputStream out = new DataOutputStream(tmpOutByteArray);

		try {
			out.write(transCode,0,9);
			out.write(textStartChar,0,3);
			out.write(msgCode,0,4);
			out.write(transSeq,0,12);
			out.write(transDate,0,14);
			out.write(rspCode,0,2);
			out.write(memberCode,0,2);
			out.write(reserve,0,18);
			//out.writeInt(size);
			out.write(data,0,size);

		} catch (IOException iex) {
			return null;
		}

		return tmpOutByteArray.toByteArray();

	}

	public boolean toObject( byte[] byteArray, int len )
	{

		init();
		if ( byteArray.length < BCComDef.BCComDataHeadSize) return false;
		
		DataInputStream in = 
				new DataInputStream(new ByteArrayInputStream(byteArray));

		try {
			in.read(transCode,0,9);
			in.read(textStartChar,0,3);
			in.read(msgCode,0,4);
			in.read(transSeq,0,12);
			in.read(transDate,0,14);
			in.read(rspCode,0,2);
			in.read(memberCode,0,2);
			in.read(reserve,0,18);
			//bccomdata.size = in.readInt();
			size = len - BCComDef.BCComDataHeadSize;
			in.read(data,0,size);
		} catch (IOException iex) {
			return false;
		}
		return true;
	}
	


}
