import java.io.*;
import java.net.*;

class COMIF implements Runnable
{
	InfoMgr infoMgr;
	int    listenPort;
		
	COMIF(InfoMgr info, int port)
	{
		
		infoMgr = info;
		listenPort = port;
		
	}
	
	public void run()
	{
		int    nrifID;
		ServerSocket listenSocket;

       		while (true) {
       			if ( infoMgr.riftab.isConnect == true ) break;
       			BCComUtil.sleep(2);
      		}
		
        	try {
        		infoMgr.log.writeLog("Starting make LOWER Listener(" + listenPort + ")...");
        		
            		
            		listenSocket = new ServerSocket(listenPort);
            		infoMgr.log.writeLog("...Succ!!");
            		while (true) 
            		{
            			Socket conn = listenSocket.accept();
            			
            			DataInputStream in = 
							new DataInputStream(conn.getInputStream());
            			DataOutputStream out = 
							new DataOutputStream(conn.getOutputStream());
            			
						// Server Connection  Check
						if ( infoMgr.riftab.isConnect != true ) 
						{
            				infoMgr.log.writeLog("No Server Connect");
            				conn.close();
            				continue;

						}

            			nrifID = infoMgr.findIFTabEmptySlot();
            			if ( nrifID < 0) {
            				infoMgr.log.writeLog("No Empty Slot");
            				conn.close();
            				continue;
            			}
            			
            			infoMgr.iftab.en[nrifID].connect = conn;
            			infoMgr.iftab.en[nrifID].in = in;
            			infoMgr.iftab.en[nrifID].out = out;
            			
            			infoMgr.log.writeLog("Client Connected. ID=[" + nrifID + "]");
            			Thread IFSVC = new Thread(new COMIFSVC(infoMgr,nrifID));
            			IFSVC.start();
       			
            		}
        	} catch (IOException e) { 
				infoMgr.log.writeLog("ServerSocket Error"); 
				System.exit(1); 
			}
	}
	

}
