import java.io.*;


class LogMgr
{
		
	LogMgr()
	{
	}
	
	synchronized void log(byte[] data, int len, String msg) 
	{
		System.out.println("[" + BCComUtil.getTime() + "]: " + msg);	
		if (data != null )
		{
			System.out.println("====> DATA (size: " + len + "\ttime: " + BCComUtil.getTime() + "<====");
		//	BCComUtil.hexaDumpHangul(System.out,data,len);	
			BCComUtil.hexaDump(System.out,data,len);	
		}
	}
	
	synchronized void writeLog(String msg) 
	{
		System.out.println("[" + BCComUtil.getTime() + "]: " + msg);		
		System.err.println("[" + BCComUtil.getTime() + "]: " + msg);		
	}
	
	
	synchronized void dumpData(byte[] data,int len)
	{
		System.out.println("====> DATA (size: " + len + "\ttime: " + BCComUtil.getTime() + "<====");
		BCComUtil.hexaDump(System.out,data,len);	
		//BCComUtil.hexaDumpHangul(System.out,data,len);	
	}

	synchronized void objDump(BCComData bc)
	{
		int len = BCComDef.BCComDataHeadSize+bc.getSize();

		String msg = "SZ:" + len + " SQ:" + bc.getTransSeq()+ 
					" MC:"+bc.getMsgCode();

		System.err.println("[" + BCComUtil.getTime() + "]: " + msg);		
		BCComUtil.objDump(System.err,bc.getData(),bc.getMsgCode());
	}

}
