#include "CSocket.h"

Csocket::Csocket()
{
}

Csocket::~Csocket()
{
}
void Csocket::socket(void)
{
	m_Ssockfd = ::socket(AF_INET, SOCK_STREAM, 0);
}

int Csocket::bind(void)
{
	return(::bind(m_Ssockfd, (const sockaddr*)&addr, (int)sizeof(struct sockaddr_in)));	
}

int Csocket::listen(void)
{
	return(::listen(m_Ssockfd, 5));
}

int Csocket::accept(void)
{
	m_Csockfd = ::accept(m_Ssockfd, NULL, NULL);
	return(m_Csockfd);
}

int Csocket::send(const char *msg, int flags)
{
	return(::send(m_Csockfd, msg, (int)strlen(msg), flags));
}

int Csocket::recv(char *buf, int flags)
{
	return(::recv(m_Csockfd, buf, 4096, flags));
}

int Csocket::open(unsigned short int port)
{
	this->socket();
	if(m_Ssockfd == -1)
		return(-1);
	addr.sin_family = AF_INET;
	addr.sin_port = htons(port);
	addr.sin_addr.s_addr = INADDR_ANY;
	bzero(&(addr.sin_zero), 8);
	if(this->bind() == -1)
		return(-2);
	if(this->listen() == -1)
		return(-3);
	return(1);
}

void Csocket::c_close(void)
{
	close(m_Csockfd);
}

void Csocket::s_close(void)
{
	close(m_Ssockfd);
}
