#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h> 
#include <sys/types.h> 
#define SIZE sizeof (struct sockaddr_in)

void catcher (int sig);

int newsockfd;

void cp_arr( char * dest, char * src, int st, int len );
int checkLength(char *packet);
int main()
{
	struct timeval timeRec;
	fd_set select_set;
	int sockfd, rc, len;
	struct sockaddr_in server = {AF_INET, 20000, INADDR_ANY};
	char c[4097];
	static struct sigaction act;

	act.sa_handler = catcher;
	sigfillset (&(act.sa_mask));
	sigaction (SIGPIPE, &act, NULL);

	if((sockfd = socket (AF_INET, SOCK_STREAM,0)) == -1)
	{
		perror("socket call failed");
		exit(1);
	}

	if(bind(sockfd,(struct sockaddr *)&server, (int)SIZE) == -1)
	{
		perror("bind call failed");
		exit(1);
	}

	if(listen(sockfd, 5) == -1)
	{
		perror("listen call failed");
		exit(1);
	}


	for(;;)
	{
		if((newsockfd = accept(sockfd, NULL, NULL)) == -1)
		{
			perror("accept call failed");
			continue;
		}

		if(fork() == 0)
		{
			int len1, len2;
			char temp[66];
			int a;
			timeRec.tv_sec = 100;
			timeRec.tv_usec= 0;
			FD_ZERO( &select_set ); 
			FD_SET( newsockfd, &select_set ); 
			printf("Client connected\n");	
			while(1)
			{
				rc = select(FD_SETSIZE, &select_set, 0, 0, &timeRec );
				if (rc > 0 && FD_ISSET(newsockfd, &select_set)) 
				{

					len1 = recv(newsockfd, &c,4096,0);
					printf("recv length[%d]\n", len1);
					if(len1 <=0)
					{
						printf("Client Disconnect\n");
						close(newsockfd);
						exit(0);
					}
					cp_arr(temp,c,1,4);
					len2=atoi(temp);
					printf("*****************%d °  Ÿ************************\n",a++);
					printf("len1=%d\n len2=%d\n", strlen(len1),len2);
					cp_arr(temp,c,6,2);
				//	printf("*********Data Record=%d\n",atoi(temp));
					printf("%s\n",c);
				//	sleep(30);
					send(newsockfd, "ok", 2, 0);
					memset(c, '\0', sizeof(c));
				}
				else if (rc == 0)
				{
					printf("5ʰ   ڽμ մϴ.\n");
					close(newsockfd);
					exit(0);
				}
				else
				{
					printf("Client Disconected\n");
					close(newsockfd);
					exit(0);
				}
			}	
		}
		close(newsockfd);
	}
	close(sockfd);
	
}

void catcher(int sig)
{
	close(newsockfd);
	exit(0);
}

void cp_arr( char * dest, char * src, int st, int len )
{
	int ndx = 0;
	int ind ;

	for( ind = st - 1; ind < st+len-1; ind ++, ndx ++)
	{
		/*if( src[ind] == ' ' )
			break;*/
		dest[ndx] = src[ind] ;
	}
	dest[ndx] = '\0';
}

int checkLength(char *packet)
{
	
}
